/***************************************************************************
 *   Copyright (C) 2003-2008 by Albert Astals Cid                          *
 *   aacid@kde.org                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef __kio_gopher_h__
#define __kio_gopher_h__

#include <kio/tcpslavebase.h>
#include <kiconloader.h>

class gopher : public KIO::TCPSlaveBase
{
	public:
		gopher(const TQByteArray &pool_socket, const TQByteArray &app_socket);

		void get(const KUrl& url);

	private:
		void processDirectory(TQByteArray *received, const TQString &host, const TQString &path);
		void processDirectoryLine(const TQByteArray &data, TQByteArray &show, TQByteArray &info);
		TQByteArray parsePort(TQByteArray *received);
		void findLine(TQByteArray *received, int *i, int *remove);
		void handleSearch(const TQString &host, const TQString &path, int port);
		void addIcon(const TQString &type, const TQByteArray &url, TQByteArray &show);
		
		KIconLoader m_iconLoader;
};

#endif

